# -*- coding: utf-8 -*-
# Programm : Buttontest2.py
# Python 3 Programm; For testing Buttons in various shapes.
# Autor: Dipl.-Ing. Bernd Wiebus alias DL1EIC
# Uedem/Germany den 19 Feb 1213
# Rights: GNU-GPL
# contact: bernd.wiebus@gmx.de


import tkinter
from tkinter.filedialog import *  # Weil das Modul "Frame" in tkinter.filedialog steckt???

# Unterprogramm zur Anzeige der Koordinaten des Events auf dem Canvas. Ihm werden in "event" die relevanten Daten übergeben.
def KoordinatenAnzeigen(event):
  laXKoord.configure(text = "X-Koordinate: " + str(event.x)) # Configuriert den Text plus der in String gewandelten  X Daten des Tupels event in das Label der X-Koordinate.
  laYKoord.configure(text = "Y-Koordinate: " + str(event.y)) # Configuriert den Text plus der in String gewandelten  Y Daten des Tupels event in das Label der Y-Koordinate.


# Unterprogramm zur Berechnung, ob ein Event im interessanten Koordinatenbereich stattgefunden hat.  Ihm werden in "event" die relevanten Daten übergeben.
# Wird nur bei Linksklicks aufgerufen.
def buttonaktion1(event):
  KoordinatenAnzeigen(event) #Ruft Unterprogramm zur Koordinatenanzeige auf.
  
  #Hier wird geprüft, ob der Bereich für den blauen Button passt.
  if event.x > 50 and event.x < 150: # Bereichsauswertung X Koordinate
    if event.y > 25 and event.y < 75: # Bereichsauswertung Y Koordinate
      laZustand.configure(text = "Zustand: blauer Button links geklickt") #Konfiguriert Text in Label
      laAktion.configure(text = "Aktion: keine Aktion über item Erkennung") #Konfiguriert Text in Label
      caDisplay.create_text(200, 400, text="P600 Dioden in unterschiedlichen Größen", fill = "orange", font = ("Arial", 16, "italic"), tags="hinweis")
      #print("Test1a")
      return() # Return hier nötig, weil sonst auch der Bereich der Schleife ausgeführt wird,
               # der weder auf den blauen noch roten Button passt.
      
  #Hier wird geprüft, ob der Bereich für den roten Button passt.    
  if event.x > 50 and event.x < 150: # Bereichsauswertung X Koordinate
    if event.y > 125 and event.y < 175: # Bereichsauswertung Y Koordinate
      laZustand.configure(text = "Zustand: roter Button links geklickt") #Konfiguriert Text in Label
      laAktion.configure(text = "Aktion: keine Aktion über item Erkennung") #Konfiguriert Text in Label
      caDisplay.delete("hinweis")
      #print("Test1b")
      return()  # Return hier nötig, weil sonst auch der Bereich der Schleife ausgeführt wird,
               # der weder auf den blauen noch roten Button passt.
  
  laZustand.configure(text = "Zustand: keine Aktion über Feld Erkennung") #Konfiguriert Text in Label
  #print("Test1c")
  
# Unterprogramm zur Berechnung, ob ein Event im interessanten Koordinatenbereich stattgefunden hat.  Ihm werden in "event" die relevanten Daten übergeben.
# Wird nur bei Rechtsklicks aufgerufen.
def buttonaktion2(event):
  KoordinatenAnzeigen(event) #Ruft Unterprogramm zur Koordinatenanzeige auf.
  
  #Hier wird geprüft, ob der Bereich für den blauen Button passt.
  if event.x > 50 and event.x < 150: # Bereichsauswertung X Koordinate
    if event.y > 25 and event.y < 75: # Bereichsauswertung Y Koordinate
      laZustand.configure(text = "Zustand: blauer Button rechts geklickt") #Konfiguriert Text in Label
      laAktion.configure(text = "Aktion: keine Aktion über item Erkennung") #Konfiguriert Text in Label
      #print("Test2a")
      return() # Return hier nötig, weil sonst auch der Bereich der Schleife ausgeführt wird,
               # der weder auf den blauen noch roten Button passt.
      
  #Hier wird geprüft, ob der Bereich für den roten Button passt.
  if event.x > 50 and event.x < 150: # Bereichsauswertung X Koordinate
    if event.y > 125 and event.y < 175: # Bereichsauswertung Y Koordinate
      laZustand.configure(text = "Zustand: roter Button rechts geklickt") #Konfiguriert Text in Label
      laAktion.configure(text = "Aktion: keine Aktion über item Erkennung") #Konfiguriert Text in Label
      #print("Test2b")
      return() # Return hier nötig, weil sonst auch der Bereich der Schleife ausgeführt wird,
               # der weder auf den blauen noch roten Button passt.
  
  laZustand.configure(text = "Zustand: keine Aktion über Feld Erkennung") #Konfiguriert Text in Label
  #print("Test2c")

# Unterprogramm, das aufgerufen wird, wenn ein Linksklick im grünen Button stattgefunden hat.
def buttonaktion3(event):
  KoordinatenAnzeigen(event) #Ruft Unterprogramm zur Koordinatenanzeige auf.
  laZustand.configure(text = "Zustand: keine Aktion über Feld Erkennung") #Konfiguriert Text in Label
  laAktion.configure(text = "letzte Aktion: grüner Button links geklickt") #Konfiguriert Text in Label
  
  #Es folgt eine Sequenz, in der willkürlich ovale Items über die Canvas verstreut werden, die ALLE
  # den Tag "rotepocken" haben.
  caDisplay.create_oval(50, 55, 55, 60, fill="red", tags = "rotepocken")
  caDisplay.create_oval(100, 105, 110, 115, fill="red", tags = "rotepocken")
  caDisplay.create_oval(200, 100, 210, 110, fill="red", tags = "rotepocken")
  caDisplay.create_oval(400, 250, 410, 265, fill="red", tags = "rotepocken")
  caDisplay.create_oval(450, 150, 460, 160, fill="red", tags = "rotepocken")
  caDisplay.create_oval(555, 55, 575, 65, fill="red", tags = "rotepocken")
  caDisplay.create_oval(380, 270, 390, 280, fill="red", tags = "rotepocken")
  caDisplay.create_oval(460, 400, 480, 420, fill="red", tags = "rotepocken")
  #print("Test3")

# Unterprogramm, das aufgerufen wird, wenn ein Rechtsklick im grünen Button stattgefunden hat.
def buttonaktion4(event):
  KoordinatenAnzeigen(event) #Ruft Unterprogramm zur Koordinatenanzeige auf.
  laZustand.configure(text = "Zustand: keine Aktion über Feld Erkennung") #Konfiguriert Text in Label
  laAktion.configure(text = "letzte Aktion: grüner Button rechts geklickt") #Konfiguriert Text in Label
  caDisplay.delete("rotepocken") #Löscht alle Items mit dem tag "rotepocken" auf der Canvas.
  #print("Test4")
   
def buttonaktion5(event):
  KoordinatenAnzeigen(event) #Ruft Unterprogramm zur Koordinatenanzeige auf.
  laZustand.configure(text = "Zustand: keine Aktion über Feld Erkennung") #Konfiguriert Text in Label
  laAktion.configure(text = "letzte Aktion: Text Button 1 links geklickt") #Konfiguriert Text in Label
  caDisplay.itemconfig("polygon1", fill = "blue")
  #print("Test5")
  
def buttonaktion6(event):
  KoordinatenAnzeigen(event) #Ruft Unterprogramm zur Koordinatenanzeige auf.
  laZustand.configure(text = "Zustand: keine Aktion über Feld Erkennung") #Konfiguriert Text in Label
  laAktion.configure(text = "letzte Aktion: Text Button 1 rechts geklickt") #Konfiguriert Text in Label
  #print("Test6")
 
def buttonaktion7(event):
  KoordinatenAnzeigen(event) #Ruft Unterprogramm zur Koordinatenanzeige auf.
  laZustand.configure(text = "Zustand: keine Aktion über Feld Erkennung") #Konfiguriert Text in Label
  laAktion.configure(text = "letzte Aktion: Text Button 2 links geklickt") #Konfiguriert Text in Label
  caDisplay.itemconfig("polygon1", fill = "green")
  #print("Test7")
 
def buttonaktion8(event):
  KoordinatenAnzeigen(event) #Ruft Unterprogramm zur Koordinatenanzeige auf.
  laZustand.configure(text = "Zustand: keine Aktion über Feld Erkennung") #Konfiguriert Text in Label
  laAktion.configure(text = "letzte Aktion: Text Button 2 rechts geklickt") #Konfiguriert Text in Label
  #print("Test8")

def buttonaktion9(event):
  KoordinatenAnzeigen(event) #Ruft Unterprogramm zur Koordinatenanzeige auf.
  laZustand.configure(text = "Zustand: keine Aktion über Feld Erkennung") #Konfiguriert Text in Label
  laAktion.configure(text = "letzte Aktion: Polygon1 links geklickt") #Konfiguriert Text in Label
  caDisplay.itemconfig("polygon1", fill = "red")
  polygontext(True)
  #print("Test9")  
  
def buttonaktion10(event):
  KoordinatenAnzeigen(event) #Ruft Unterprogramm zur Koordinatenanzeige auf.
  laZustand.configure(text = "Zustand: keine Aktion über Feld Erkennung") #Konfiguriert Text in Label
  laAktion.configure(text = "letzte Aktion: Polygon1 rechts geklickt") #Konfiguriert Text in Label
  polygontext(False)
  #print("Test10")
  
def buttonaktion11(event):
  KoordinatenAnzeigen(event) #Ruft Unterprogramm zur Koordinatenanzeige auf.
  laZustand.configure(text = "Zustand: keine Aktion über Feld Erkennung") #Konfiguriert Text in Label
  laAktion.configure(text = "letzte Aktion: Text ""irregulaerer button"" links geklickt") #Konfiguriert Text in Label
  caDisplay.itemconfig(caDisplay.canvlabPolygon1, fill = "red", text = "links angeklickt")
  #print("Test11")
  
def buttonaktion12(event):
  KoordinatenAnzeigen(event) #Ruft Unterprogramm zur Koordinatenanzeige auf.
  laZustand.configure(text = "Zustand: keine Aktion über Feld Erkennung") #Konfiguriert Text in Label
  laAktion.configure(text = "letzte Aktion: Text ""irregulaerer button"" rechts geklickt") #Konfiguriert Text in Label
  caDisplay.itemconfig(caDisplay.canvlabPolygon1, fill = "red", text = "rechts angeklickt")
  #print("Test12")
  
def buttonaktion13(event):
  KoordinatenAnzeigen(event) #Ruft Unterprogramm zur Koordinatenanzeige auf.
  laZustand.configure(text = "Zustand: keine Aktion über Feld Erkennung") #Konfiguriert Text in Label
  laAktion.configure(text = "letzte Aktion: rote Pocken links oder rechts geklickt") #Konfiguriert Text in Label
  caDisplay.delete("rotepocken")
  #print("Test13")
  
def buttonaktion14(event):
  KoordinatenAnzeigen(event) #Ruft Unterprogramm zur Koordinatenanzeige auf.
  caDisplay.delete("hinweispolygon")
  caDisplay.create_text(600, 130, text="Polygon Button", fill = "orange", font = ("Arial", 16, "italic"), tags="hinweispolygon")
  laAktion.configure(text = "letzte Aktion: Hilfetext Polygon") #Konfiguriert Text in Label
  #print("Test14")
  
def buttonaktion15(event):
  KoordinatenAnzeigen(event) #Ruft Unterprogramm zur Koordinatenanzeige auf.
  caDisplay.delete("hinweispolygon")
  laAktion.configure(text = "letzte Aktion: Hilfetext Polygon löschen") #Konfiguriert Text in Label
  #print("Test15")


def polygontext(boEigenschaft):
  if boEigenschaft == True:
    caDisplay.delete("irregulaer")
    caDisplay.canvlabPolygon1 = caDisplay.create_text(500, 275, text="irregulaerer Button", fill = "red", tags = "irregulaer")
    return()
  if boEigenschaft == False:
    caDisplay.delete("irregulaer")
    return()


  

  
# Hauptfenster
Hauptfenster = tkinter.Tk()
Hauptfenster.title ("Buttontest1")


# Rahmen1
Rahmen1 = Frame(Hauptfenster, background = "#002040")
Rahmen1.pack(side = TOP, fill = X)

# Rahmen2
Rahmen2 = Frame(Hauptfenster, background = "#002040")
Rahmen2.pack(side = TOP, fill = X)

# Rahmen3
Rahmen3 = Frame(Hauptfenster, background = "#002040")
Rahmen3.pack(side = TOP, fill = X)

#Label zur Darstellung der X-Koordinate
laXKoord = tkinter.Label(Rahmen1, text = "X-Koordinate:      ", background = "#002040",foreground = "#FFFF5F")
laXKoord.pack(side = LEFT, fill = X)

#Label zur Darstellung der Y-Koordinate
laYKoord = tkinter.Label(Rahmen1, text = "X-Koordinate:      ", background = "#002040",foreground = "#FFFF5F")
laYKoord.pack(side = LEFT, fill = X)

#Label zur Darstellung des Zustandes der Felderkennung
laZustand = tkinter.Label(Rahmen1, text = "Zustand:       ", background = "#002040",foreground = "#FFFF5F")
laZustand.pack(side = LEFT, fill = X)

#Label zur Darstellung des Zustandes der Aktion
laAktion = tkinter.Label(Rahmen2, text = "Aktion:       ", background = "#002040",foreground = "#FFFF5F")
laAktion.pack(side = LEFT, fill = X)

# dummylabel zum bildspeichern

Bildfile = "P600-Dioden2.gif"
Bild = tkinter.PhotoImage(width=700, height=500, file=Bildfile) #Bildfile muss im gleichen Ordner stehen wie das Programm.

# Canvas fuer display
caDisplay = Canvas(Rahmen3, width=700, height=500, background="white")
caDisplay.image = Bild #Referenz auf das bild am Objekt speichern, damit es wegen Garbage collegtion nicht verschwindet. 

 
Hintergrund = caDisplay.create_image(350, 250, image = Bild, tags = "hintergrund")

fbuBlau = caDisplay.create_rectangle(50, 25, 150, 75, fill="blue")
fbuRed = caDisplay.create_rectangle(50, 125, 150, 175, fill="red")
fbuGreen = caDisplay.create_oval(50, 225, 150, 325, fill="green", width=5, activefill="yellow", tags = "greenbutton")
fbuText1 = caDisplay.create_text(400, 175, text="TestTextObjekt1", fill ="blue", tags = "textbutton1")
fbuTex2 = caDisplay.create_text(400, 70, text="TestTextObjekt2", fill = "red", tags="textbutton2")
fbuPolygon1 = caDisplay.create_polygon(500, 100, 550, 175, 575, 200, 525, 250, 500, 125, fill="red", tags = "polygon1")



caDisplay.bind("<Button-1>", buttonaktion1)
caDisplay.bind("<Button-3>", buttonaktion2)

caDisplay.tag_bind("greenbutton", "<ButtonPress-1>", buttonaktion3)
caDisplay.tag_bind("greenbutton", "<ButtonPress-3>", buttonaktion4)
caDisplay.tag_bind("textbutton1", "<ButtonPress-1>", buttonaktion5)
caDisplay.tag_bind("textbutton1", "<ButtonPress-3>", buttonaktion6)
caDisplay.tag_bind("textbutton2", "<ButtonPress-1>", buttonaktion7)   
caDisplay.tag_bind("textbutton2", "<ButtonPress-3>", buttonaktion8) 
caDisplay.tag_bind("polygon1", "<ButtonPress-1>", buttonaktion9)
caDisplay.tag_bind("polygon1", "<ButtonPress-3>", buttonaktion10)
caDisplay.tag_bind("irregulaer", "<ButtonPress-1>", buttonaktion11)
caDisplay.tag_bind("irregulaer", "<ButtonPress-3>", buttonaktion12)
caDisplay.tag_bind("rotepocken", "<ButtonPress-1>", buttonaktion13)
caDisplay.tag_bind("rotepocken", "<ButtonPress-3>", buttonaktion13)
caDisplay.tag_bind("polygon1", "<Enter>", buttonaktion14)
caDisplay.tag_bind("polygon1", "<Leave>", buttonaktion15)
caDisplay.pack(side= RIGHT)




# endlosschleife
Hauptfenster.mainloop()







